-- control.lua
-- Apr 2017

function CreateTagGui(event)
  local player = game.players[event.player_index]
  if player.gui.top.tag == nil then
  	  player.gui.top.add{name="tag", type="button", caption="タグ"}
  end   
end

-- Tag list
local roles = {
  {display_name = "[ソロ]"},
  {display_name = "[掘削]"},
  {display_name = "[電力]"},
  {display_name = "[原油処理]"},
  {display_name = "[焼き場]"},
  {display_name = "[鉄道]"},
  {display_name = "[防衛]"},
  {display_name = "[回路]"},
  {display_name = "[サイエンス]"},
  {display_name = "[物流]"},
  {display_name = "[その他]"},
  {display_name = "[侵攻]"},
  {display_name = "[ロケット]"},
  {display_name = "[離席]"},
  {display_name = "消去"}}

local function ExpandTagGui(player)
    local frame = player.gui.left["tag-panel"]
    if (frame) then
        frame.destroy()
    else
        local frame = player.gui.left.add{type="frame", name="tag-panel", caption="現在の工程 : "}
        local contents = frame.add{type="flow", name="contents", direction="vertical"}
        local tag_buttons = contents.add{type="flow", name="tag-buttons", direction="horizontal"}
    		for _, role in pairs(roles) do
    			tag_buttons.add{type="button", caption=role.display_name, name=role.display_name}
        end
        contents.add{type="label", caption="任意入力", name="any_label"}
        local any_tags = contents.add{type="flow", name="any_tags", direction="horizontal"}
        any_tags.add{type="textfield", name="any_display_name"}
        any_tags.any_display_name.text = ""
        any_tags.add{type="button", caption="決定", name="any_decide"}
    end
end

function TagGuiClick(event) 
    if not (event and event.element and event.element.valid) then return end
    local player = game.players[event.element.player_index]
    local name = event.element.name
    local frame = player.gui.left["tag-panel"]

		if (name == "tag") then
			ExpandTagGui(player)
		end
		
		if (name == "消去") then 
			player.tag = ""
			return
		end
    
		for _, role in pairs(roles) do
			if (name == role.display_name) then
				player.tag = role.display_name
      end
		end

    if (name == "any_decide") then
      player.tag = ""
      if (frame and frame.contents.any_tags.any_display_name.text ~= "") then
        if (#frame.contents.any_tags.any_display_name.text <= 30) then
          player.tag = "[" .. frame.contents.any_tags.any_display_name.text .. "]"
        end
      end
    end
end
